"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var react_1 = tslib_1.__importStar(require("react"));
var lodash_throttle_1 = tslib_1.__importDefault(require("lodash.throttle"));
var usePaintSquare_1 = tslib_1.__importDefault(require("./usePaintSquare"));
var context_1 = require("./context");
var Square = function () {
    var _a = (0, context_1.usePicker)(), handleColor = _a.handleColor, x = _a.x, y = _a.y, internalHue = _a.internalHue;
    var _b = (0, react_1.useState)(false), dragging = _b[0], setDragging = _b[1];
    var canvas = (0, react_1.useRef)(null);
    (0, usePaintSquare_1.default)(canvas, internalHue);
    var handleChange = function (e) {
        var _a;
        var ctx = (_a = canvas === null || canvas === void 0 ? void 0 : canvas.current) === null || _a === void 0 ? void 0 : _a.getContext("2d");
        var onMouseMove = (0, lodash_throttle_1.default)(function () { return handleColor(e, ctx); }, 250);
        onMouseMove();
    };
    var stopDragging = function () {
        setDragging(false);
    };
    var handleMove = function (e) {
        if (dragging) {
            handleChange(e);
        }
    };
    var handleClick = function (e) {
        if (!dragging) {
            handleChange(e);
        }
    };
    return (react_1.default.createElement("div", { style: { position: "relative" } },
        react_1.default.createElement("div", { style: {
                position: "absolute",
                left: -7,
                top: -7,
                width: 308,
                height: 308
            }, onMouseEnter: stopDragging }),
        react_1.default.createElement("div", { style: { position: "relative", cursor: "crosshair" }, onMouseMove: function (e) { return handleMove(e); }, onMouseUp: stopDragging },
            react_1.default.createElement("div", { style: {
                    left: x,
                    top: y,
                    position: "absolute",
                    border: "2px solid white",
                    borderRadius: "50%",
                    boxShadow: "0px 0px 3px rgba(0,0,0,.5)",
                    width: 18,
                    height: 18,
                    zIndex: 1000
                }, className: "handle", onMouseDown: function () { return setDragging(true); } }),
            react_1.default.createElement("div", { className: "canvas-wrapper", onClick: function (e) { return handleClick(e); } },
                react_1.default.createElement("canvas", { ref: canvas, width: "294px", height: "294px", id: "paintSquare" })))));
};
exports.default = Square;
//# sourceMappingURL=Square.js.map